#include <amxmodx>
#include <fun>
#include <cstrike>
#include <hamsandwich>

// Pcvar globals
new pCvarPlugin_on, pCvarPrice;
new pCvarHealthOn
new pCvarArmorOn
new pCvarSpeedOn
new pCvarGravityOn
new gMainMenu;

// Boolerean
new bool:GotDemonic[33]

public plugin_init()
{
	register_plugin ( "Suit", "1.1", "Crash94");
	
	register_event("HLTV","event_newround",	"a","1=0","2=0") 
	
	RegisterHam( Ham_TakeDamage, "player", "Player_TookDamage" )
	
	// Register say command for menu
	register_clcmd("suit", "showMenu_MainMenu");
	register_clcmd("say_team /suit", "showMenu_MainMenu");

	// Register pcvars
	pCvarPlugin_on = register_cvar("amx_suit_on", "1")
	pCvarPrice = register_cvar("amx_suit_money", "10000")
	pCvarHealthOn = register_cvar ( "amx_suit_health", "1" )
	pCvarArmorOn = register_cvar ( "amx_suit_armor", "1" )
	pCvarSpeedOn = register_cvar ( "amx_suit_speed", "1" )
	pCvarGravityOn = register_cvar ( "amx_suit_gravity", "1" )
	
	// More Menu stuff
	gMainMenu = register_menuid("Main Menu");
	register_menucmd(gMainMenu, 1023, "actionMenu_MainMenu");
}

public event_newround(id)
{
	GotDemonic[id] = false;
}

public client_putinserver( id )
{
	GotDemonic[id] = false;
	set_task ( 3.0, "msgAdv", id )
}

public msgAdv ( id )
{
	set_task ( 60.0, "msgAdv", id )
	//client_print ( id, print_chat, "Наберите /suit и купите себе мего костюм" )
	//client_print ( id, print_chat, "Но - вы потеряете некоторые приемущества - скорость и гравитацию" )
	if( !is_user_connected( id ) )
	{
		remove_task( id )
	}
}

public client_disconnect(id)
{
	GotDemonic[id] = false;
}

public showMenu_MainMenu(id)
{
	if( is_user_alive( id ) )
	{
		new szBuffer[512], iLen;
		new iBuffer = sizeof szBuffer - 1
	
		iLen = formatex(szBuffer, iBuffer, "\rМеню покупки!^n^n");
		iLen += formatex(szBuffer[iLen], (iBuffer) - iLen, "\r1. \wКупить (%d)^n", get_pcvar_num(pCvarPrice));
		iLen += formatex(szBuffer[iLen], (iBuffer) - iLen, "\r0. \wВыход");
	
		new iKeys = ( 1<<0 | 1<<1 | 1<<9 );
		show_menu(id, iKeys, szBuffer, -1, "Main Menu");
	}
	else
	{
		client_print( id, print_chat, "Вы мертвы, не нужен вам костюм" )
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

public actionMenu_MainMenu(id, key)
{
	switch(key)
	{
		case 0:
		{
			if ( get_pcvar_num ( pCvarPlugin_on ) )
			{
				new iCPrice = get_pcvar_num ( pCvarPrice ) 
				new iMoney = cs_get_user_money(id)

				if ( iMoney >= iCPrice )
				{
					cs_set_user_money ( id, iMoney - iCPrice )
					
					demon( id )
					GotDemonic[id] = true
				}
				else
				{
					client_print(id, print_chat,"У вас нехватает денег,чтобы купить костюм")
				}
				if ( get_user_health ( id ) > 100 )
				{
					client_print(id, print_chat, "Вы купили костюм - Вперед")
				
				}
			}
		}
	}
	return PLUGIN_HANDLED;
}

public Player_TookDamage( iVictim, iInflictor, iAttacker, Float:Damage, iDamage_type )
{
	if(GotDemonic[ iAttacker ] == true )
	{
		if( !is_user_alive( iAttacker ) || cs_get_user_team( iAttacker ) == cs_get_user_team( iVictim ) )
			return HAM_IGNORED
			
		if( ( iDamage_type & ( 1<<1 ) ) )
		{
			set_user_health( iAttacker, get_user_health( iAttacker ) + floatround( Damage ) / 5 )
			client_print( iAttacker, print_chat, "You got %d extra hp for damaging", Damage / 5 )
		}
	}
	return HAM_IGNORED
}
demon( id )
{
	if ( get_pcvar_num ( pCvarArmorOn ) )
	{
		set_user_armor ( id, random_num ( 200, 200 ) )
	}	
	if ( get_pcvar_num ( pCvarHealthOn ) )
	{			
		set_user_health ( id, random_num ( 200, 200 ) )
	}
	if ( get_pcvar_num ( pCvarSpeedOn ) )
	{
		set_user_maxspeed ( id, random_float ( 180.0, 180.0 ) )
	}
	if ( get_pcvar_num ( pCvarGravityOn ) )
	{
		set_user_gravity ( id, random_float ( 2.0, 2.0 ) )
	}
	set_user_rendering(id, kRenderFxGlowShell, 234, 11, 50, kRenderTransAlpha, 255); 
}
